// prefs
var autocopyPrefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("autocopy.");

window.addEventListener("load",function() {initAutoCopyStatus();} ,true);
window.addEventListener("focus",function() {resetAutoCopyStatus();} ,true);

function initAutoCopyStatus() 
{

    initPreferences();
}


function resetAutoCopyStatus()
{
    initAutoCopyStatus()
}




function initPreferences(){

	if (!autocopyPrefs.prefHasUserValue("optEnableAutocopy"))
		autocopyPrefs.setBoolPref("optEnableAutocopy", true);
	if (!autocopyPrefs.prefHasUserValue("optEnableInTextBoxes"))
		autocopyPrefs.setBoolPref("optEnableInTextBoxes", true);
}



window.onmouseup = TextSelected;
window.onkeyup = onKeyUpCheck;

function onKeyUpCheck(e)
{
	
	if(e.keyCode == e.DOM_VK_A && e.ctrlKey)
	{
		TextSelected(e);
	}
}


function TextSelected(e){
   var gstate = true;
   if(autocopyPrefs.prefHasUserValue("optEnableAutocopy"))
   {
       gstate = autocopyPrefs.getBoolPref("optEnableAutocopy");
   }


   if(gstate){
	var targetclassname = e.target.toString();
	if (!targetclassname.match(/object XUL/i))
	{
		if(!targetclassname.match(/SelectElement|OptionElement/i))
		{
			if(!targetclassname.match(/InputElement|TextAreaElement/i) || autocopyPrefs.getBoolPref("optEnableInTextBoxes"))
			{
				goDoCommand('cmd_copy');
			}
		}
	}
   }
}

